var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { isObservable, of, pipe } from "rxjs";
import { mergeScan, switchMap } from "rxjs/operators";
export var patchScan = pipe(mergeScan(function (state, update) {
    if (update instanceof Function) {
        var result = update(state);
        if (isObservable(result)) {
            return result.pipe(switchMap(function (foo) {
                if (foo instanceof Function)
                    return of(foo(state));
                return of(foo);
            }));
        }
        return of(result);
    }
    return of(__assign({}, state, update));
}));
