var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Stream } from "./stream";
import { plan } from "./plan";
import { concat, of } from "rxjs";
var StreamProps = (function (_super) {
    __extends(StreamProps, _super);
    function StreamProps() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StreamProps.prototype.configureSource = function (props) {
        this.updateProps = plan();
        return concat(of(props), this.updateProps);
    };
    StreamProps.prototype.componentDidUpdate = function () {
        this.updateProps(this.props);
    };
    return StreamProps;
}(Stream));
export { StreamProps };
export var streamProps = function (pipe, plans) { return function (props, context) {
    return new StreamProps(props, context, { pipe: pipe, plans: plans });
}; };
