import { Observable, observable } from "rxjs";
import { share, startWith } from "rxjs/operators";
export function behaviorPlan(start) {
    var _a;
    var operators = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        operators[_i - 1] = arguments[_i];
    }
    var next;
    var o$ = (_a = new Observable(function (observer) {
        next = function () {
            var arg = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                arg[_i] = arguments[_i];
            }
            observer.next.apply(observer, arg);
            return o$;
        };
    })).pipe.apply(_a, operators.concat([share(),
        startWith(start)]));
    var unsubscribe = o$.subscribe();
    next["unsubscribe"] = unsubscribe;
    next[observable] = function () { return o$; };
    return next;
}
