import { from } from "rxjs";
import { concatMap, mergeScan } from "rxjs/operators";
export var scanSequence = function () {
    var plans = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        plans[_i] = arguments[_i];
    }
    return concatMap(function (value) {
        return from(plans.slice()).pipe(mergeScan(function (prev, next) {
            console.log({ prev: prev, next: next });
            return next(prev);
        }, value, 1));
    });
};
