import { from, of } from "rxjs";
import { concatAll, concatMap, scan, switchMap } from "rxjs/operators";
export var sequence = function () {
    var plans = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        plans[_i] = arguments[_i];
    }
    return concatMap(function (value) {
        return from(plans.slice()).pipe(scan(function (prev, next) { return prev.pipe(switchMap(next)); }, of(value)), concatAll());
    });
};
